function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
import { getBabelChain } from "@modern-js/babel-preset-lib";
import { getBuildInPlugins } from "./built-in";
var getBabelConfig = function(modulePresetOption, syntaxOption) {
    var chain = getModuleBabelChain(modulePresetOption, syntaxOption);
    return _objectSpread({
        sourceType: "unambiguous"
    }, chain.toJSON());
};
var getModuleBabelChain = function(modulePresetOption, syntaxOption) {
    var chain = getBabelChain(modulePresetOption, syntaxOption);
    chain.plugin("@babel/plugin-proposal-do-expressions").use(require.resolve("@babel/plugin-proposal-do-expressions"));
    chain.plugin("@babel/plugin-proposal-throw-expressions").use(require.resolve("@babel/plugin-proposal-throw-expressions"));
    chain.plugin("@babel/plugin-proposal-class-static-block").use(require.resolve("@babel/plugin-proposal-class-static-block"));
    chain.plugin("@babel/plugin-proposal-function-sent").use(require.resolve("@babel/plugin-proposal-function-sent"));
    var buildInPlugins = getBuildInPlugins({
        importStyle: modulePresetOption.importStyle,
        staticDir: modulePresetOption.staticDir,
        styleDir: modulePresetOption.styleDir,
        sourceDir: modulePresetOption.sourceDir
    });
    chain.merge(buildInPlugins);
    return chain;
};
var getFinalBabelConfig = function(chain) {
    return _objectSpread({
        sourceType: "unambiguous"
    }, chain.toJSON());
};
export * from "./types";
import { applyUserBabelConfig } from "@modern-js/utils";
export { applyUserBabelConfig, getBabelConfig, getFinalBabelConfig, getModuleBabelChain };
